/*!
 * Chart.js v4.0.1
 * https://www.chartjs.org
 * (c) 2022 Chart.js Contributors
 * Released under the MIT License
 */
function noop(){}const uid=(()=>{let e=0;return()=>e++})();function isNullOrUndef(e){return null==e}function isArray(e){if(Array.isArray&&Array.isArray(e))return!0;const t=Object.prototype.toString.call(e);return"[object"===t.slice(0,7)&&"Array]"===t.slice(-6)}function isObject(e){return null!==e&&"[object Object]"===Object.prototype.toString.call(e)}function isNumberFinite(e){return("number"==typeof e||e instanceof Number)&&isFinite(+e)}function finiteOrDefault(e,t){return isNumberFinite(e)?e:t}function valueOrDefault(e,t){return void 0===e?t:e}const toPercentage=(e,t)=>"string"==typeof e&&e.endsWith("%")?parseFloat(e)/100:+e/t,toDimension=(e,t)=>"string"==typeof e&&e.endsWith("%")?parseFloat(e)/100*t:+e;function callback(e,t,n){if(e&&"function"==typeof e.call)return e.apply(n,t)}function each(e,t,n,r){let o,a,i;if(isArray(e))if(a=e.length,r)for(o=a-1;o>=0;o--)t.call(n,e[o],o);else for(o=0;o<a;o++)t.call(n,e[o],o);else if(isObject(e))for(i=Object.keys(e),a=i.length,o=0;o<a;o++)t.call(n,e[i[o]],i[o])}function _elementsEqual(e,t){let n,r,o,a;if(!e||!t||e.length!==t.length)return!1;for(n=0,r=e.length;n<r;++n)if(o=e[n],a=t[n],o.datasetIndex!==a.datasetIndex||o.index!==a.index)return!1;return!0}function clone$1(e){if(isArray(e))return e.map(clone$1);if(isObject(e)){const t=Object.create(null),n=Object.keys(e),r=n.length;let o=0;for(;o<r;++o)t[n[o]]=clone$1(e[n[o]]);return t}return e}function isValidKey(e){return-1===["__proto__","prototype","constructor"].indexOf(e)}function _merger(e,t,n,r){if(!isValidKey(e))return;const o=t[e],a=n[e];isObject(o)&&isObject(a)?merge(o,a,r):t[e]=clone$1(a)}function merge(e,t,n){const r=isArray(t)?t:[t],o=r.length;if(!isObject(e))return e;const a=(n=n||{}).merger||_merger;let i;for(let t=0;t<o;++t){if(i=r[t],!isObject(i))continue;const o=Object.keys(i);for(let t=0,r=o.length;t<r;++t)a(o[t],e,i,n)}return e}function mergeIf(e,t){return merge(e,t,{merger:_mergerIf})}function _mergerIf(e,t,n){if(!isValidKey(e))return;const r=t[e],o=n[e];isObject(r)&&isObject(o)?mergeIf(r,o):Object.prototype.hasOwnProperty.call(t,e)||(t[e]=clone$1(o))}function _deprecated(e,t,n,r){void 0!==t&&console.warn(e+': "'+n+'" is deprecated. Please use "'+r+'" instead')}const keyResolvers={"":e=>e,x:e=>e.x,y:e=>e.y};function _splitKey(e){const t=e.split("."),n=[];let r="";for(const e of t)r+=e,r.endsWith("\\")?r=r.slice(0,-1)+".":(n.push(r),r="");return n}function _getKeyResolver(e){const t=_splitKey(e);return e=>{for(const n of t){if(""===n)break;e=e&&e[n]}return e}}function resolveObjectKey(e,t){return(keyResolvers[t]||(keyResolvers[t]=_getKeyResolver(t)))(e)}function _capitalize(e){return e.charAt(0).toUpperCase()+e.slice(1)}const defined=e=>void 0!==e,isFunction=e=>"function"==typeof e,setsEqual=(e,t)=>{if(e.size!==t.size)return!1;for(const n of e)if(!t.has(n))return!1;return!0};function _isClickEvent(e){return"mouseup"===e.type||"click"===e.type||"contextmenu"===e.type}const PI=Math.PI,TAU=2*PI,PITAU=TAU+PI,INFINITY=Number.POSITIVE_INFINITY,RAD_PER_DEG=PI/180,HALF_PI=PI/2,QUARTER_PI=PI/4,TWO_THIRDS_PI=2*PI/3,log10=Math.log10,sign=Math.sign;function almostEquals(e,t,n){return Math.abs(e-t)<n}function niceNum(e){const t=Math.round(e);e=almostEquals(e,t,e/1e3)?t:e;const n=Math.pow(10,Math.floor(log10(e))),r=e/n;return(r<=1?1:r<=2?2:r<=5?5:10)*n}function _factorize(e){const t=[],n=Math.sqrt(e);let r;for(r=1;r<n;r++)e%r==0&&(t.push(r),t.push(e/r));return n===(0|n)&&t.push(n),t.sort(((e,t)=>e-t)).pop(),t}function isNumber(e){return!isNaN(parseFloat(e))&&isFinite(e)}function almostWhole(e,t){const n=Math.round(e);return n-t<=e&&n+t>=e}function _setMinAndMaxByKey(e,t,n){let r,o,a;for(r=0,o=e.length;r<o;r++)a=e[r][n],isNaN(a)||(t.min=Math.min(t.min,a),t.max=Math.max(t.max,a))}function toRadians(e){return e*(PI/180)}function toDegrees(e){return e*(180/PI)}function _decimalPlaces(e){if(!isNumberFinite(e))return;let t=1,n=0;for(;Math.round(e*t)/t!==e;)t*=10,n++;return n}function getAngleFromPoint(e,t){const n=t.x-e.x,r=t.y-e.y,o=Math.sqrt(n*n+r*r);let a=Math.atan2(r,n);return a<-.5*PI&&(a+=TAU),{angle:a,distance:o}}function distanceBetweenPoints(e,t){return Math.sqrt(Math.pow(t.x-e.x,2)+Math.pow(t.y-e.y,2))}function _angleDiff(e,t){return(e-t+PITAU)%TAU-PI}function _normalizeAngle(e){return(e%TAU+TAU)%TAU}function _angleBetween(e,t,n,r){const o=_normalizeAngle(e),a=_normalizeAngle(t),i=_normalizeAngle(n),s=_normalizeAngle(a-o),l=_normalizeAngle(i-o),c=_normalizeAngle(o-a),u=_normalizeAngle(o-i);return o===a||o===i||r&&a===i||s>l&&c<u}function _limitValue(e,t,n){return Math.max(t,Math.min(n,e))}function _int16Range(e){return _limitValue(e,-32768,32767)}function _isBetween(e,t,n,r=1e-6){return e>=Math.min(t,n)-r&&e<=Math.max(t,n)+r}function _lookup(e,t,n){n=n||(n=>e[n]<t);let r,o=e.length-1,a=0;for(;o-a>1;)r=a+o>>1,n(r)?a=r:o=r;return{lo:a,hi:o}}const _lookupByKey=(e,t,n,r)=>_lookup(e,n,r?r=>{const o=e[r][t];return o<n||o===n&&e[r+1][t]===n}:r=>e[r][t]<n),_rlookupByKey=(e,t,n)=>_lookup(e,n,(r=>e[r][t]>=n));function _filterBetween(e,t,n){let r=0,o=e.length;for(;r<o&&e[r]<t;)r++;for(;o>r&&e[o-1]>n;)o--;return r>0||o<e.length?e.slice(r,o):e}const arrayEvents=["push","pop","shift","splice","unshift"];function listenArrayEvents(e,t){e._chartjs?e._chartjs.listeners.push(t):(Object.defineProperty(e,"_chartjs",{configurable:!0,enumerable:!1,value:{listeners:[t]}}),arrayEvents.forEach((t=>{const n="_onData"+_capitalize(t),r=e[t];Object.defineProperty(e,t,{configurable:!0,enumerable:!1,value(...t){const o=r.apply(this,t);return e._chartjs.listeners.forEach((e=>{"function"==typeof e[n]&&e[n](...t)})),o}})})))}function unlistenArrayEvents(e,t){const n=e._chartjs;if(!n)return;const r=n.listeners,o=r.indexOf(t);-1!==o&&r.splice(o,1),r.length>0||(arrayEvents.forEach((t=>{delete e[t]})),delete e._chartjs)}function _arrayUnique(e){const t=new Set;let n,r;for(n=0,r=e.length;n<r;++n)t.add(e[n]);return t.size===r?e:Array.from(t)}function fontString(e,t,n){return t+" "+e+"px "+n}const requestAnimFrame="undefined"==typeof window?function(e){return e()}:window.requestAnimationFrame;function throttled(e,t){let n=!1;return function(...r){n||(n=!0,requestAnimFrame.call(window,(()=>{n=!1,e.apply(t,r)})))}}function debounce(e,t){let n;return function(...r){return t?(clearTimeout(n),n=setTimeout(e,t,r)):e.apply(this,r),t}}const _toLeftRightCenter=e=>"start"===e?"left":"end"===e?"right":"center",_alignStartEnd=(e,t,n)=>"start"===e?t:"end"===e?n:(t+n)/2,_textX=(e,t,n,r)=>e===(r?"left":"right")?n:"center"===e?(t+n)/2:t;function _getStartAndCountOfVisiblePoints(e,t,n){const r=t.length;let o=0,a=r;if(e._sorted){const{iScale:i,_parsed:s}=e,l=i.axis,{min:c,max:u,minDefined:f,maxDefined:d}=i.getUserBounds();f&&(o=_limitValue(Math.min(_lookupByKey(s,i.axis,c).lo,n?r:_lookupByKey(t,l,i.getPixelForValue(c)).lo),0,r-1)),a=d?_limitValue(Math.max(_lookupByKey(s,i.axis,u,!0).hi+1,n?0:_lookupByKey(t,l,i.getPixelForValue(u),!0).hi+1),o,r)-o:r-o}return{start:o,count:a}}function _scaleRangesChanged(e){const{xScale:t,yScale:n,_scaleRanges:r}=e,o={xmin:t.min,xmax:t.max,ymin:n.min,ymax:n.max};if(!r)return e._scaleRanges=o,!0;const a=r.xmin!==t.min||r.xmax!==t.max||r.ymin!==n.min||r.ymax!==n.max;return Object.assign(r,o),a}const atEdge=e=>0===e||1===e,elasticIn=(e,t,n)=>-Math.pow(2,10*(e-=1))*Math.sin((e-t)*TAU/n),elasticOut=(e,t,n)=>Math.pow(2,-10*e)*Math.sin((e-t)*TAU/n)+1,effects={linear:e=>e,easeInQuad:e=>e*e,easeOutQuad:e=>-e*(e-2),easeInOutQuad:e=>(e/=.5)<1?.5*e*e:-.5*(--e*(e-2)-1),easeInCubic:e=>e*e*e,easeOutCubic:e=>(e-=1)*e*e+1,easeInOutCubic:e=>(e/=.5)<1?.5*e*e*e:.5*((e-=2)*e*e+2),easeInQuart:e=>e*e*e*e,easeOutQuart:e=>-((e-=1)*e*e*e-1),easeInOutQuart:e=>(e/=.5)<1?.5*e*e*e*e:-.5*((e-=2)*e*e*e-2),easeInQuint:e=>e*e*e*e*e,easeOutQuint:e=>(e-=1)*e*e*e*e+1,easeInOutQuint:e=>(e/=.5)<1?.5*e*e*e*e*e:.5*((e-=2)*e*e*e*e+2),easeInSine:e=>1-Math.cos(e*HALF_PI),easeOutSine:e=>Math.sin(e*HALF_PI),easeInOutSine:e=>-.5*(Math.cos(PI*e)-1),easeInExpo:e=>0===e?0:Math.pow(2,10*(e-1)),easeOutExpo:e=>1===e?1:1-Math.pow(2,-10*e),easeInOutExpo:e=>atEdge(e)?e:e<.5?.5*Math.pow(2,10*(2*e-1)):.5*(2-Math.pow(2,-10*(2*e-1))),easeInCirc:e=>e>=1?e:-(Math.sqrt(1-e*e)-1),easeOutCirc:e=>Math.sqrt(1-(e-=1)*e),easeInOutCirc:e=>(e/=.5)<1?-.5*(Math.sqrt(1-e*e)-1):.5*(Math.sqrt(1-(e-=2)*e)+1),easeInElastic:e=>atEdge(e)?e:elasticIn(e,.075,.3),easeOutElastic:e=>atEdge(e)?e:elasticOut(e,.075,.3),easeInOutElastic(e){const t=.1125;return atEdge(e)?e:e<.5?.5*elasticIn(2*e,t,.45):.5+.5*elasticOut(2*e-1,t,.45)},easeInBack(e){const t=1.70158;return e*e*((t+1)*e-t)},easeOutBack(e){const t=1.70158;return(e-=1)*e*((t+1)*e+t)+1},easeInOutBack(e){let t=1.70158;return(e/=.5)<1?e*e*((1+(t*=1.525))*e-t)*.5:.5*((e-=2)*e*((1+(t*=1.525))*e+t)+2)},easeInBounce:e=>1-effects.easeOutBounce(1-e),easeOutBounce(e){const t=7.5625,n=2.75;return e<1/n?t*e*e:e<2/n?t*(e-=1.5/n)*e+.75:e<2.5/n?t*(e-=2.25/n)*e+.9375:t*(e-=2.625/n)*e+.984375},easeInOutBounce:e=>e<.5?.5*effects.easeInBounce(2*e):.5*effects.easeOutBounce(2*e-1)+.5};var effects$1=effects;
/*!
 * @kurkle/color v0.2.1
 * https://github.com/kurkle/color#readme
 * (c) 2022 Jukka Kurkela
 * Released under the MIT License
 */function round(e){return e+.5|0}const lim=(e,t,n)=>Math.max(Math.min(e,n),t);function p2b(e){return lim(round(2.55*e),0,255)}function n2b(e){return lim(round(255*e),0,255)}function b2n(e){return lim(round(e/2.55)/100,0,1)}function n2p(e){return lim(round(100*e),0,100)}const map$1={0:0,1:1,2:2,3:3,4:4,5:5,6:6,7:7,8:8,9:9,A:10,B:11,C:12,D:13,E:14,F:15,a:10,b:11,c:12,d:13,e:14,f:15},hex=[..."0123456789ABCDEF"],h1=e=>hex[15&e],h2=e=>hex[(240&e)>>4]+hex[15&e],eq=e=>(240&e)>>4==(15&e),isShort=e=>eq(e.r)&&eq(e.g)&&eq(e.b)&&eq(e.a);function hexParse(e){var t,n=e.length;return"#"===e[0]&&(4===n||5===n?t={r:255&17*map$1[e[1]],g:255&17*map$1[e[2]],b:255&17*map$1[e[3]],a:5===n?17*map$1[e[4]]:255}:7!==n&&9!==n||(t={r:map$1[e[1]]<<4|map$1[e[2]],g:map$1[e[3]]<<4|map$1[e[4]],b:map$1[e[5]]<<4|map$1[e[6]],a:9===n?map$1[e[7]]<<4|map$1[e[8]]:255})),t}const alpha=(e,t)=>e<255?t(e):"";function hexString(e){var t=isShort(e)?h1:h2;return e?"#"+t(e.r)+t(e.g)+t(e.b)+alpha(e.a,t):void 0}const HUE_RE=/^(hsla?|hwb|hsv)\(\s*([-+.e\d]+)(?:deg)?[\s,]+([-+.e\d]+)%[\s,]+([-+.e\d]+)%(?:[\s,]+([-+.e\d]+)(%)?)?\s*\)$/;function hsl2rgbn(e,t,n){const r=t*Math.min(n,1-n),o=(t,o=(t+e/30)%12)=>n-r*Math.max(Math.min(o-3,9-o,1),-1);return[o(0),o(8),o(4)]}function hsv2rgbn(e,t,n){const r=(r,o=(r+e/60)%6)=>n-n*t*Math.max(Math.min(o,4-o,1),0);return[r(5),r(3),r(1)]}function hwb2rgbn(e,t,n){const r=hsl2rgbn(e,1,.5);let o;for(t+n>1&&(o=1/(t+n),t*=o,n*=o),o=0;o<3;o++)r[o]*=1-t-n,r[o]+=t;return r}function hueValue(e,t,n,r,o){return e===o?(t-n)/r+(t<n?6:0):t===o?(n-e)/r+2:(e-t)/r+4}function rgb2hsl(e){const t=e.r/255,n=e.g/255,r=e.b/255,o=Math.max(t,n,r),a=Math.min(t,n,r),i=(o+a)/2;let s,l,c;return o!==a&&(c=o-a,l=i>.5?c/(2-o-a):c/(o+a),s=hueValue(t,n,r,c,o),s=60*s+.5),[0|s,l||0,i]}function calln(e,t,n,r){return(Array.isArray(t)?e(t[0],t[1],t[2]):e(t,n,r)).map(n2b)}function hsl2rgb(e,t,n){return calln(hsl2rgbn,e,t,n)}function hwb2rgb(e,t,n){return calln(hwb2rgbn,e,t,n)}function hsv2rgb(e,t,n){return calln(hsv2rgbn,e,t,n)}function hue(e){return(e%360+360)%360}function hueParse(e){const t=HUE_RE.exec(e);let n,r=255;if(!t)return;t[5]!==n&&(r=t[6]?p2b(+t[5]):n2b(+t[5]));const o=hue(+t[2]),a=+t[3]/100,i=+t[4]/100;return n="hwb"===t[1]?hwb2rgb(o,a,i):"hsv"===t[1]?hsv2rgb(o,a,i):hsl2rgb(o,a,i),{r:n[0],g:n[1],b:n[2],a:r}}function rotate(e,t){var n=rgb2hsl(e);n[0]=hue(n[0]+t),n=hsl2rgb(n),e.r=n[0],e.g=n[1],e.b=n[2]}function hslString(e){if(!e)return;const t=rgb2hsl(e),n=t[0],r=n2p(t[1]),o=n2p(t[2]);return e.a<255?`hsla(${n}, ${r}%, ${o}%, ${b2n(e.a)})`:`hsl(${n}, ${r}%, ${o}%)`}const map={x:"dark",Z:"light",Y:"re",X:"blu",W:"gr",V:"medium",U:"slate",A:"ee",T:"ol",S:"or",B:"ra",C:"lateg",D:"ights",R:"in",Q:"turquois",E:"hi",P:"ro",O:"al",N:"le",M:"de",L:"yello",F:"en",K:"ch",G:"arks",H:"ea",I:"ightg",J:"wh"},names$1={OiceXe:"f0f8ff",antiquewEte:"faebd7",aqua:"ffff",aquamarRe:"7fffd4",azuY:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"0",blanKedOmond:"ffebcd",Xe:"ff",XeviTet:"8a2be2",bPwn:"a52a2a",burlywood:"deb887",caMtXe:"5f9ea0",KartYuse:"7fff00",KocTate:"d2691e",cSO:"ff7f50",cSnflowerXe:"6495ed",cSnsilk:"fff8dc",crimson:"dc143c",cyan:"ffff",xXe:"8b",xcyan:"8b8b",xgTMnPd:"b8860b",xWay:"a9a9a9",xgYF:"6400",xgYy:"a9a9a9",xkhaki:"bdb76b",xmagFta:"8b008b",xTivegYF:"556b2f",xSange:"ff8c00",xScEd:"9932cc",xYd:"8b0000",xsOmon:"e9967a",xsHgYF:"8fbc8f",xUXe:"483d8b",xUWay:"2f4f4f",xUgYy:"2f4f4f",xQe:"ced1",xviTet:"9400d3",dAppRk:"ff1493",dApskyXe:"bfff",dimWay:"696969",dimgYy:"696969",dodgerXe:"1e90ff",fiYbrick:"b22222",flSOwEte:"fffaf0",foYstWAn:"228b22",fuKsia:"ff00ff",gaRsbSo:"dcdcdc",ghostwEte:"f8f8ff",gTd:"ffd700",gTMnPd:"daa520",Way:"808080",gYF:"8000",gYFLw:"adff2f",gYy:"808080",honeyMw:"f0fff0",hotpRk:"ff69b4",RdianYd:"cd5c5c",Rdigo:"4b0082",ivSy:"fffff0",khaki:"f0e68c",lavFMr:"e6e6fa",lavFMrXsh:"fff0f5",lawngYF:"7cfc00",NmoncEffon:"fffacd",ZXe:"add8e6",ZcSO:"f08080",Zcyan:"e0ffff",ZgTMnPdLw:"fafad2",ZWay:"d3d3d3",ZgYF:"90ee90",ZgYy:"d3d3d3",ZpRk:"ffb6c1",ZsOmon:"ffa07a",ZsHgYF:"20b2aa",ZskyXe:"87cefa",ZUWay:"778899",ZUgYy:"778899",ZstAlXe:"b0c4de",ZLw:"ffffe0",lime:"ff00",limegYF:"32cd32",lRF:"faf0e6",magFta:"ff00ff",maPon:"800000",VaquamarRe:"66cdaa",VXe:"cd",VScEd:"ba55d3",VpurpN:"9370db",VsHgYF:"3cb371",VUXe:"7b68ee",VsprRggYF:"fa9a",VQe:"48d1cc",VviTetYd:"c71585",midnightXe:"191970",mRtcYam:"f5fffa",mistyPse:"ffe4e1",moccasR:"ffe4b5",navajowEte:"ffdead",navy:"80",Tdlace:"fdf5e6",Tive:"808000",TivedBb:"6b8e23",Sange:"ffa500",SangeYd:"ff4500",ScEd:"da70d6",pOegTMnPd:"eee8aa",pOegYF:"98fb98",pOeQe:"afeeee",pOeviTetYd:"db7093",papayawEp:"ffefd5",pHKpuff:"ffdab9",peru:"cd853f",pRk:"ffc0cb",plum:"dda0dd",powMrXe:"b0e0e6",purpN:"800080",YbeccapurpN:"663399",Yd:"ff0000",Psybrown:"bc8f8f",PyOXe:"4169e1",saddNbPwn:"8b4513",sOmon:"fa8072",sandybPwn:"f4a460",sHgYF:"2e8b57",sHshell:"fff5ee",siFna:"a0522d",silver:"c0c0c0",skyXe:"87ceeb",UXe:"6a5acd",UWay:"708090",UgYy:"708090",snow:"fffafa",sprRggYF:"ff7f",stAlXe:"4682b4",tan:"d2b48c",teO:"8080",tEstN:"d8bfd8",tomato:"ff6347",Qe:"40e0d0",viTet:"ee82ee",JHt:"f5deb3",wEte:"ffffff",wEtesmoke:"f5f5f5",Lw:"ffff00",LwgYF:"9acd32"};function unpack(){const e={},t=Object.keys(names$1),n=Object.keys(map);let r,o,a,i,s;for(r=0;r<t.length;r++){for(i=s=t[r],o=0;o<n.length;o++)a=n[o],s=s.replace(a,map[a]);a=parseInt(names$1[i],16),e[s]=[a>>16&255,a>>8&255,255&a]}return e}let names;function nameParse(e){names||(names=unpack(),names.transparent=[0,0,0,0]);const t=names[e.toLowerCase()];return t&&{r:t[0],g:t[1],b:t[2],a:4===t.length?t[3]:255}}const RGB_RE=/^rgba?\(\s*([-+.\d]+)(%)?[\s,]+([-+.e\d]+)(%)?[\s,]+([-+.e\d]+)(%)?(?:[\s,/]+([-+.e\d]+)(%)?)?\s*\)$/;function rgbParse(e){const t=RGB_RE.exec(e);let n,r,o,a=255;if(t){if(t[7]!==n){const e=+t[7];a=t[8]?p2b(e):lim(255*e,0,255)}return n=+t[1],r=+t[3],o=+t[5],n=255&(t[2]?p2b(n):lim(n,0,255)),r=255&(t[4]?p2b(r):lim(r,0,255)),o=255&(t[6]?p2b(o):lim(o,0,255)),{r:n,g:r,b:o,a}}}function rgbString(e){return e&&(e.a<255?`rgba(${e.r}, ${e.g}, ${e.b}, ${b2n(e.a)})`:`rgb(${e.r}, ${e.g}, ${e.b})`)}const to=e=>e<=.0031308?12.92*e:1.055*Math.pow(e,1/2.4)-.055,from=e=>e<=.04045?e/12.92:Math.pow((e+.055)/1.055,2.4);function interpolate(e,t,n){const r=from(b2n(e.r)),o=from(b2n(e.g)),a=from(b2n(e.b));return{r:n2b(to(r+n*(from(b2n(t.r))-r))),g:n2b(to(o+n*(from(b2n(t.g))-o))),b:n2b(to(a+n*(from(b2n(t.b))-a))),a:e.a+n*(t.a-e.a)}}function modHSL(e,t,n){if(e){let r=rgb2hsl(e);r[t]=Math.max(0,Math.min(r[t]+r[t]*n,0===t?360:1)),r=hsl2rgb(r),e.r=r[0],e.g=r[1],e.b=r[2]}}function clone(e,t){return e?Object.assign(t||{},e):e}function fromObject(e){var t={r:0,g:0,b:0,a:255};return Array.isArray(e)?e.length>=3&&(t={r:e[0],g:e[1],b:e[2],a:255},e.length>3&&(t.a=n2b(e[3]))):(t=clone(e,{r:0,g:0,b:0,a:1})).a=n2b(t.a),t}function functionParse(e){return"r"===e.charAt(0)?rgbParse(e):hueParse(e)}class Color{constructor(e){if(e instanceof Color)return e;const t=typeof e;let n;"object"===t?n=fromObject(e):"string"===t&&(n=hexParse(e)||nameParse(e)||functionParse(e)),this._rgb=n,this._valid=!!n}get valid(){return this._valid}get rgb(){var e=clone(this._rgb);return e&&(e.a=b2n(e.a)),e}set rgb(e){this._rgb=fromObject(e)}rgbString(){return this._valid?rgbString(this._rgb):void 0}hexString(){return this._valid?hexString(this._rgb):void 0}hslString(){return this._valid?hslString(this._rgb):void 0}mix(e,t){if(e){const n=this.rgb,r=e.rgb;let o;const a=t===o?.5:t,i=2*a-1,s=n.a-r.a,l=((i*s==-1?i:(i+s)/(1+i*s))+1)/2;o=1-l,n.r=255&l*n.r+o*r.r+.5,n.g=255&l*n.g+o*r.g+.5,n.b=255&l*n.b+o*r.b+.5,n.a=a*n.a+(1-a)*r.a,this.rgb=n}return this}interpolate(e,t){return e&&(this._rgb=interpolate(this._rgb,e._rgb,t)),this}clone(){return new Color(this.rgb)}alpha(e){return this._rgb.a=n2b(e),this}clearer(e){return this._rgb.a*=1-e,this}greyscale(){const e=this._rgb,t=round(.3*e.r+.59*e.g+.11*e.b);return e.r=e.g=e.b=t,this}opaquer(e){return this._rgb.a*=1+e,this}negate(){const e=this._rgb;return e.r=255-e.r,e.g=255-e.g,e.b=255-e.b,this}lighten(e){return modHSL(this._rgb,2,e),this}darken(e){return modHSL(this._rgb,2,-e),this}saturate(e){return modHSL(this._rgb,1,e),this}desaturate(e){return modHSL(this._rgb,1,-e),this}rotate(e){return rotate(this._rgb,e),this}}function index_esm(e){return new Color(e)}function isPatternOrGradient(e){if(e&&"object"==typeof e){const t=e.toString();return"[object CanvasPattern]"===t||"[object CanvasGradient]"===t}return!1}function color(e){return isPatternOrGradient(e)?e:index_esm(e)}function getHoverColor(e){return isPatternOrGradient(e)?e:index_esm(e).saturate(.5).darken(.1).hexString()}const numbers=["x","y","borderWidth","radius","tension"],colors=["color","borderColor","backgroundColor"];function applyAnimationsDefaults(e){e.set("animation",{delay:void 0,duration:1e3,easing:"easeOutQuart",fn:void 0,from:void 0,loop:void 0,to:void 0,type:void 0}),e.describe("animation",{_fallback:!1,_indexable:!1,_scriptable:e=>"onProgress"!==e&&"onComplete"!==e&&"fn"!==e}),e.set("animations",{colors:{type:"color",properties:colors},numbers:{type:"number",properties:numbers}}),e.describe("animations",{_fallback:"animation"}),e.set("transitions",{active:{animation:{duration:400}},resize:{animation:{duration:0}},show:{animations:{colors:{from:"transparent"},visible:{type:"boolean",duration:0}}},hide:{animations:{colors:{to:"transparent"},visible:{type:"boolean",easing:"linear",fn:e=>0|e}}}})}function applyLayoutsDefaults(e){e.set("layout",{autoPadding:!0,padding:{top:0,right:0,bottom:0,left:0}})}const intlCache=new Map;function getNumberFormat(e,t){t=t||{};const n=e+JSON.stringify(t);let r=intlCache.get(n);return r||(r=new Intl.NumberFormat(e,t),intlCache.set(n,r)),r}function formatNumber(e,t,n){return getNumberFormat(t,n).format(e)}const formatters={values:e=>isArray(e)?e:""+e,numeric(e,t,n){if(0===e)return"0";const r=this.chart.options.locale;let o,a=e;if(n.length>1){const t=Math.max(Math.abs(n[0].value),Math.abs(n[n.length-1].value));(t<1e-4||t>1e15)&&(o="scientific"),a=calculateDelta(e,n)}const i=log10(Math.abs(a)),s=Math.max(Math.min(-1*Math.floor(i),20),0),l={notation:o,minimumFractionDigits:s,maximumFractionDigits:s};return Object.assign(l,this.options.ticks.format),formatNumber(e,r,l)},logarithmic(e,t,n){if(0===e)return"0";const r=n[t].significand||e/Math.pow(10,Math.floor(log10(e)));return[1,2,3,5,10,15].includes(r)||t>.8*n.length?formatters.numeric.call(this,e,t,n):""}};function calculateDelta(e,t){let n=t.length>3?t[2].value-t[1].value:t[1].value-t[0].value;return Math.abs(n)>=1&&e!==Math.floor(e)&&(n=e-Math.floor(e)),n}var Ticks={formatters};function applyScaleDefaults(e){e.set("scale",{display:!0,offset:!1,reverse:!1,beginAtZero:!1,bounds:"ticks",grace:0,grid:{display:!0,lineWidth:1,drawOnChartArea:!0,drawTicks:!0,tickLength:8,tickWidth:(e,t)=>t.lineWidth,tickColor:(e,t)=>t.color,offset:!1},border:{display:!0,dash:[],dashOffset:0,width:1},title:{display:!1,text:"",padding:{top:4,bottom:4}},ticks:{minRotation:0,maxRotation:50,mirror:!1,textStrokeWidth:0,textStrokeColor:"",padding:3,display:!0,autoSkip:!0,autoSkipPadding:3,labelOffset:0,callback:Ticks.formatters.values,minor:{},major:{},align:"center",crossAlign:"near",showLabelBackdrop:!1,backdropColor:"rgba(255, 255, 255, 0.75)",backdropPadding:2}}),e.route("scale.ticks","color","","color"),e.route("scale.grid","color","","borderColor"),e.route("scale.border","color","","borderColor"),e.route("scale.title","color","","color"),e.describe("scale",{_fallback:!1,_scriptable:e=>!e.startsWith("before")&&!e.startsWith("after")&&"callback"!==e&&"parser"!==e,_indexable:e=>"borderDash"!==e&&"tickBorderDash"!==e&&"dash"!==e}),e.describe("scales",{_fallback:"scale"}),e.describe("scale.ticks",{_scriptable:e=>"backdropPadding"!==e&&"callback"!==e,_indexable:e=>"backdropPadding"!==e})}const overrides=Object.create(null),descriptors=Object.create(null);function getScope$1(e,t){if(!t)return e;const n=t.split(".");for(let t=0,r=n.length;t<r;++t){const r=n[t];e=e[r]||(e[r]=Object.create(null))}return e}function set(e,t,n){return"string"==typeof t?merge(getScope$1(e,t),n):merge(getScope$1(e,""),t)}class Defaults{constructor(e,t){this.animation=void 0,this.backgroundColor="rgba(0,0,0,0.1)",this.borderColor="rgba(0,0,0,0.1)",this.color="#666",this.datasets={},this.devicePixelRatio=e=>e.chart.platform.getDevicePixelRatio(),this.elements={},this.events=["mousemove","mouseout","click","touchstart","touchmove"],this.font={family:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",size:12,style:"normal",lineHeight:1.2,weight:null},this.hover={},this.hoverBackgroundColor=(e,t)=>getHoverColor(t.backgroundColor),this.hoverBorderColor=(e,t)=>getHoverColor(t.borderColor),this.hoverColor=(e,t)=>getHoverColor(t.color),this.indexAxis="x",this.interaction={mode:"nearest",intersect:!0,includeInvisible:!1},this.maintainAspectRatio=!0,this.onHover=null,this.onClick=null,this.parsing=!0,this.plugins={},this.responsive=!0,this.scale=void 0,this.scales={},this.showLine=!0,this.drawActiveElementsOnTop=!0,this.describe(e),this.apply(t)}set(e,t){return set(this,e,t)}get(e){return getScope$1(this,e)}describe(e,t){return set(descriptors,e,t)}override(e,t){return set(overrides,e,t)}route(e,t,n,r){const o=getScope$1(this,e),a=getScope$1(this,n),i="_"+t;Object.defineProperties(o,{[i]:{value:o[t],writable:!0},[t]:{enumerable:!0,get(){const e=this[i],t=a[r];return isObject(e)?Object.assign({},t,e):valueOrDefault(e,t)},set(e){this[i]=e}}})}apply(e){e.forEach((e=>e(this)))}}var defaults=new Defaults({_scriptable:e=>!e.startsWith("on"),_indexable:e=>"events"!==e,hover:{_fallback:"interaction"},interaction:{_scriptable:!1,_indexable:!1}},[applyAnimationsDefaults,applyLayoutsDefaults,applyScaleDefaults]);function toFontString(e){return!e||isNullOrUndef(e.size)||isNullOrUndef(e.family)?null:(e.style?e.style+" ":"")+(e.weight?e.weight+" ":"")+e.size+"px "+e.family}function _measureText(e,t,n,r,o){let a=t[o];return a||(a=t[o]=e.measureText(o).width,n.push(o)),a>r&&(r=a),r}function _longestText(e,t,n,r){let o=(r=r||{}).data=r.data||{},a=r.garbageCollect=r.garbageCollect||[];r.font!==t&&(o=r.data={},a=r.garbageCollect=[],r.font=t),e.save(),e.font=t;let i=0;const s=n.length;let l,c,u,f,d;for(l=0;l<s;l++)if(f=n[l],null!=f&&!0!==isArray(f))i=_measureText(e,o,a,i,f);else if(isArray(f))for(c=0,u=f.length;c<u;c++)d=f[c],null==d||isArray(d)||(i=_measureText(e,o,a,i,d));e.restore();const h=a.length/2;if(h>n.length){for(l=0;l<h;l++)delete o[a[l]];a.splice(0,h)}return i}function _alignPixel(e,t,n){const r=e.currentDevicePixelRatio,o=0!==n?Math.max(n/2,.5):0;return Math.round((t-o)*r)/r+o}function clearCanvas(e,t){(t=t||e.getContext("2d")).save(),t.resetTransform(),t.clearRect(0,0,e.width,e.height),t.restore()}function drawPoint(e,t,n,r){drawPointLegend(e,t,n,r,null)}function drawPointLegend(e,t,n,r,o){let a,i,s,l,c,u,f,d;const h=t.pointStyle,g=t.rotation,p=t.radius;let b=(g||0)*RAD_PER_DEG;if(h&&"object"==typeof h&&(a=h.toString(),"[object HTMLImageElement]"===a||"[object HTMLCanvasElement]"===a))return e.save(),e.translate(n,r),e.rotate(b),e.drawImage(h,-h.width/2,-h.height/2,h.width,h.height),void e.restore();if(!(isNaN(p)||p<=0)){switch(e.beginPath(),h){default:o?e.ellipse(n,r,o/2,p,0,0,TAU):e.arc(n,r,p,0,TAU),e.closePath();break;case"triangle":u=o?o/2:p,e.moveTo(n+Math.sin(b)*u,r-Math.cos(b)*p),b+=TWO_THIRDS_PI,e.lineTo(n+Math.sin(b)*u,r-Math.cos(b)*p),b+=TWO_THIRDS_PI,e.lineTo(n+Math.sin(b)*u,r-Math.cos(b)*p),e.closePath();break;case"rectRounded":c=.516*p,l=p-c,i=Math.cos(b+QUARTER_PI)*l,f=Math.cos(b+QUARTER_PI)*(o?o/2-c:l),s=Math.sin(b+QUARTER_PI)*l,d=Math.sin(b+QUARTER_PI)*(o?o/2-c:l),e.arc(n-f,r-s,c,b-PI,b-HALF_PI),e.arc(n+d,r-i,c,b-HALF_PI,b),e.arc(n+f,r+s,c,b,b+HALF_PI),e.arc(n-d,r+i,c,b+HALF_PI,b+PI),e.closePath();break;case"rect":if(!g){l=Math.SQRT1_2*p,u=o?o/2:l,e.rect(n-u,r-l,2*u,2*l);break}b+=QUARTER_PI;case"rectRot":f=Math.cos(b)*(o?o/2:p),i=Math.cos(b)*p,s=Math.sin(b)*p,d=Math.sin(b)*(o?o/2:p),e.moveTo(n-f,r-s),e.lineTo(n+d,r-i),e.lineTo(n+f,r+s),e.lineTo(n-d,r+i),e.closePath();break;case"crossRot":b+=QUARTER_PI;case"cross":f=Math.cos(b)*(o?o/2:p),i=Math.cos(b)*p,s=Math.sin(b)*p,d=Math.sin(b)*(o?o/2:p),e.moveTo(n-f,r-s),e.lineTo(n+f,r+s),e.moveTo(n+d,r-i),e.lineTo(n-d,r+i);break;case"star":f=Math.cos(b)*(o?o/2:p),i=Math.cos(b)*p,s=Math.sin(b)*p,d=Math.sin(b)*(o?o/2:p),e.moveTo(n-f,r-s),e.lineTo(n+f,r+s),e.moveTo(n+d,r-i),e.lineTo(n-d,r+i),b+=QUARTER_PI,f=Math.cos(b)*(o?o/2:p),i=Math.cos(b)*p,s=Math.sin(b)*p,d=Math.sin(b)*(o?o/2:p),e.moveTo(n-f,r-s),e.lineTo(n+f,r+s),e.moveTo(n+d,r-i),e.lineTo(n-d,r+i);break;case"line":i=o?o/2:Math.cos(b)*p,s=Math.sin(b)*p,e.moveTo(n-i,r-s),e.lineTo(n+i,r+s);break;case"dash":e.moveTo(n,r),e.lineTo(n+Math.cos(b)*(o?o/2:p),r+Math.sin(b)*p)}e.fill(),t.borderWidth>0&&e.stroke()}}function _isPointInArea(e,t,n){return n=n||.5,!t||e&&e.x>t.left-n&&e.x<t.right+n&&e.y>t.top-n&&e.y<t.bottom+n}function clipArea(e,t){e.save(),e.beginPath(),e.rect(t.left,t.top,t.right-t.left,t.bottom-t.top),e.clip()}function unclipArea(e){e.restore()}function _steppedLineTo(e,t,n,r,o){if(!t)return e.lineTo(n.x,n.y);if("middle"===o){const r=(t.x+n.x)/2;e.lineTo(r,t.y),e.lineTo(r,n.y)}else"after"===o!=!!r?e.lineTo(t.x,n.y):e.lineTo(n.x,t.y);e.lineTo(n.x,n.y)}function _bezierCurveTo(e,t,n,r){if(!t)return e.lineTo(n.x,n.y);e.bezierCurveTo(r?t.cp1x:t.cp2x,r?t.cp1y:t.cp2y,r?n.cp2x:n.cp1x,r?n.cp2y:n.cp1y,n.x,n.y)}function renderText(e,t,n,r,o,a={}){const i=isArray(t)?t:[t],s=a.strokeWidth>0&&""!==a.strokeColor;let l,c;for(e.save(),e.font=o.string,setRenderOpts(e,a),l=0;l<i.length;++l)c=i[l],a.backdrop&&drawBackdrop(e,a.backdrop),s&&(a.strokeColor&&(e.strokeStyle=a.strokeColor),isNullOrUndef(a.strokeWidth)||(e.lineWidth=a.strokeWidth),e.strokeText(c,n,r,a.maxWidth)),e.fillText(c,n,r,a.maxWidth),decorateText(e,n,r,c,a),r+=o.lineHeight;e.restore()}function setRenderOpts(e,t){t.translation&&e.translate(t.translation[0],t.translation[1]),isNullOrUndef(t.rotation)||e.rotate(t.rotation),t.color&&(e.fillStyle=t.color),t.textAlign&&(e.textAlign=t.textAlign),t.textBaseline&&(e.textBaseline=t.textBaseline)}function decorateText(e,t,n,r,o){if(o.strikethrough||o.underline){const a=e.measureText(r),i=t-a.actualBoundingBoxLeft,s=t+a.actualBoundingBoxRight,l=n-a.actualBoundingBoxAscent,c=n+a.actualBoundingBoxDescent,u=o.strikethrough?(l+c)/2:c;e.strokeStyle=e.fillStyle,e.beginPath(),e.lineWidth=o.decorationWidth||2,e.moveTo(i,u),e.lineTo(s,u),e.stroke()}}function drawBackdrop(e,t){const n=e.fillStyle;e.fillStyle=t.color,e.fillRect(t.left,t.top,t.width,t.height),e.fillStyle=n}function addRoundedRectPath(e,t){const{x:n,y:r,w:o,h:a,radius:i}=t;e.arc(n+i.topLeft,r+i.topLeft,i.topLeft,-HALF_PI,PI,!0),e.lineTo(n,r+a-i.bottomLeft),e.arc(n+i.bottomLeft,r+a-i.bottomLeft,i.bottomLeft,PI,HALF_PI,!0),e.lineTo(n+o-i.bottomRight,r+a),e.arc(n+o-i.bottomRight,r+a-i.bottomRight,i.bottomRight,HALF_PI,0,!0),e.lineTo(n+o,r+i.topRight),e.arc(n+o-i.topRight,r+i.topRight,i.topRight,0,-HALF_PI,!0),e.lineTo(n+i.topLeft,r)}const LINE_HEIGHT=/^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/,FONT_STYLE=/^(normal|italic|initial|inherit|unset|(oblique( -?[0-9]?[0-9]deg)?))$/;function toLineHeight(e,t){const n=(""+e).match(LINE_HEIGHT);if(!n||"normal"===n[1])return 1.2*t;switch(e=+n[2],n[3]){case"px":return e;case"%":e/=100}return t*e}const numberOrZero=e=>+e||0;function _readValueToProps(e,t){const n={},r=isObject(t),o=r?Object.keys(t):t,a=isObject(e)?r?n=>valueOrDefault(e[n],e[t[n]]):t=>e[t]:()=>e;for(const e of o)n[e]=+a(e)||0;return n}function toTRBL(e){return _readValueToProps(e,{top:"y",right:"x",bottom:"y",left:"x"})}function toTRBLCorners(e){return _readValueToProps(e,["topLeft","topRight","bottomLeft","bottomRight"])}function toPadding(e){const t=toTRBL(e);return t.width=t.left+t.right,t.height=t.top+t.bottom,t}function toFont(e,t){e=e||{},t=t||defaults.font;let n=valueOrDefault(e.size,t.size);"string"==typeof n&&(n=parseInt(n,10));let r=valueOrDefault(e.style,t.style);r&&!(""+r).match(FONT_STYLE)&&(console.warn('Invalid font style specified: "'+r+'"'),r=void 0);const o={family:valueOrDefault(e.family,t.family),lineHeight:toLineHeight(valueOrDefault(e.lineHeight,t.lineHeight),n),size:n,style:r,weight:valueOrDefault(e.weight,t.weight),string:""};return o.string=toFontString(o),o}function resolve(e,t,n,r){let o,a,i,s=!0;for(o=0,a=e.length;o<a;++o)if(i=e[o],void 0!==i&&(void 0!==t&&"function"==typeof i&&(i=i(t),s=!1),void 0!==n&&isArray(i)&&(i=i[n%i.length],s=!1),void 0!==i))return r&&!s&&(r.cacheable=!1),i}function _addGrace(e,t,n){const{min:r,max:o}=e,a=toDimension(t,(o-r)/2),i=(e,t)=>n&&0===e?0:e+t;return{min:i(r,-Math.abs(a)),max:i(o,a)}}function createContext(e,t){return Object.assign(Object.create(e),t)}function _createResolver(e,t=[""],n=e,r,o=(()=>e[0])){defined(r)||(r=_resolve("_fallback",e));const a={[Symbol.toStringTag]:"Object",_cacheable:!0,_scopes:e,_rootScopes:n,_fallback:r,_getTarget:o,override:o=>_createResolver([o,...e],t,n,r)};return new Proxy(a,{deleteProperty:(t,n)=>(delete t[n],delete t._keys,delete e[0][n],!0),get:(n,r)=>_cached(n,r,(()=>_resolveWithPrefixes(r,t,e,n))),getOwnPropertyDescriptor:(e,t)=>Reflect.getOwnPropertyDescriptor(e._scopes[0],t),getPrototypeOf:()=>Reflect.getPrototypeOf(e[0]),has:(e,t)=>getKeysFromAllScopes(e).includes(t),ownKeys:e=>getKeysFromAllScopes(e),set(e,t,n){const r=e._storage||(e._storage=o());return e[t]=r[t]=n,delete e._keys,!0}})}function _attachContext(e,t,n,r){const o={_cacheable:!1,_proxy:e,_context:t,_subProxy:n,_stack:new Set,_descriptors:_descriptors(e,r),setContext:t=>_attachContext(e,t,n,r),override:o=>_attachContext(e.override(o),t,n,r)};return new Proxy(o,{deleteProperty:(t,n)=>(delete t[n],delete e[n],!0),get:(e,t,n)=>_cached(e,t,(()=>_resolveWithContext(e,t,n))),getOwnPropertyDescriptor:(t,n)=>t._descriptors.allKeys?Reflect.has(e,n)?{enumerable:!0,configurable:!0}:void 0:Reflect.getOwnPropertyDescriptor(e,n),getPrototypeOf:()=>Reflect.getPrototypeOf(e),has:(t,n)=>Reflect.has(e,n),ownKeys:()=>Reflect.ownKeys(e),set:(t,n,r)=>(e[n]=r,delete t[n],!0)})}function _descriptors(e,t={scriptable:!0,indexable:!0}){const{_scriptable:n=t.scriptable,_indexable:r=t.indexable,_allKeys:o=t.allKeys}=e;return{allKeys:o,scriptable:n,indexable:r,isScriptable:isFunction(n)?n:()=>n,isIndexable:isFunction(r)?r:()=>r}}const readKey=(e,t)=>e?e+_capitalize(t):t,needsSubResolver=(e,t)=>isObject(t)&&"adapters"!==e&&(null===Object.getPrototypeOf(t)||t.constructor===Object);function _cached(e,t,n){if(Object.prototype.hasOwnProperty.call(e,t))return e[t];const r=n();return e[t]=r,r}function _resolveWithContext(e,t,n){const{_proxy:r,_context:o,_subProxy:a,_descriptors:i}=e;let s=r[t];return isFunction(s)&&i.isScriptable(t)&&(s=_resolveScriptable(t,s,e,n)),isArray(s)&&s.length&&(s=_resolveArray(t,s,e,i.isIndexable)),needsSubResolver(t,s)&&(s=_attachContext(s,o,a&&a[t],i)),s}function _resolveScriptable(e,t,n,r){const{_proxy:o,_context:a,_subProxy:i,_stack:s}=n;if(s.has(e))throw new Error("Recursion detected: "+Array.from(s).join("->")+"->"+e);return s.add(e),t=t(a,i||r),s.delete(e),needsSubResolver(e,t)&&(t=createSubResolver(o._scopes,o,e,t)),t}function _resolveArray(e,t,n,r){const{_proxy:o,_context:a,_subProxy:i,_descriptors:s}=n;if(defined(a.index)&&r(e))t=t[a.index%t.length];else if(isObject(t[0])){const n=t,r=o._scopes.filter((e=>e!==n));t=[];for(const l of n){const n=createSubResolver(r,o,e,l);t.push(_attachContext(n,a,i&&i[e],s))}}return t}function resolveFallback(e,t,n){return isFunction(e)?e(t,n):e}const getScope=(e,t)=>!0===e?t:"string"==typeof e?resolveObjectKey(t,e):void 0;function addScopes(e,t,n,r,o){for(const a of t){const t=getScope(n,a);if(t){e.add(t);const a=resolveFallback(t._fallback,n,o);if(defined(a)&&a!==n&&a!==r)return a}else if(!1===t&&defined(r)&&n!==r)return null}return!1}function createSubResolver(e,t,n,r){const o=t._rootScopes,a=resolveFallback(t._fallback,n,r),i=[...e,...o],s=new Set;s.add(r);let l=addScopesFromKey(s,i,n,a||n,r);return null!==l&&((!defined(a)||a===n||(l=addScopesFromKey(s,i,a,l,r),null!==l))&&_createResolver(Array.from(s),[""],o,a,(()=>subGetTarget(t,n,r))))}function addScopesFromKey(e,t,n,r,o){for(;n;)n=addScopes(e,t,n,r,o);return n}function subGetTarget(e,t,n){const r=e._getTarget();t in r||(r[t]={});const o=r[t];return isArray(o)&&isObject(n)?n:o||{}}function _resolveWithPrefixes(e,t,n,r){let o;for(const a of t)if(o=_resolve(readKey(a,e),n),defined(o))return needsSubResolver(e,o)?createSubResolver(n,r,e,o):o}function _resolve(e,t){for(const n of t){if(!n)continue;const t=n[e];if(defined(t))return t}}function getKeysFromAllScopes(e){let t=e._keys;return t||(t=e._keys=resolveKeysFromAllScopes(e._scopes)),t}function resolveKeysFromAllScopes(e){const t=new Set;for(const n of e)for(const e of Object.keys(n).filter((e=>!e.startsWith("_"))))t.add(e);return Array.from(t)}function _parseObjectDataRadialScale(e,t,n,r){const{iScale:o}=e,{key:a="r"}=this._parsing,i=new Array(r);let s,l,c,u;for(s=0,l=r;s<l;++s)c=s+n,u=t[c],i[s]={r:o.parse(resolveObjectKey(u,a),c)};return i}const EPSILON=Number.EPSILON||1e-14,getPoint=(e,t)=>t<e.length&&!e[t].skip&&e[t],getValueAxis=e=>"x"===e?"y":"x";function splineCurve(e,t,n,r){const o=e.skip?t:e,a=t,i=n.skip?t:n,s=distanceBetweenPoints(a,o),l=distanceBetweenPoints(i,a);let c=s/(s+l),u=l/(s+l);c=isNaN(c)?0:c,u=isNaN(u)?0:u;const f=r*c,d=r*u;return{previous:{x:a.x-f*(i.x-o.x),y:a.y-f*(i.y-o.y)},next:{x:a.x+d*(i.x-o.x),y:a.y+d*(i.y-o.y)}}}function monotoneAdjust(e,t,n){const r=e.length;let o,a,i,s,l,c=getPoint(e,0);for(let u=0;u<r-1;++u)l=c,c=getPoint(e,u+1),l&&c&&(almostEquals(t[u],0,EPSILON)?n[u]=n[u+1]=0:(o=n[u]/t[u],a=n[u+1]/t[u],s=Math.pow(o,2)+Math.pow(a,2),s<=9||(i=3/Math.sqrt(s),n[u]=o*i*t[u],n[u+1]=a*i*t[u])))}function monotoneCompute(e,t,n="x"){const r=getValueAxis(n),o=e.length;let a,i,s,l=getPoint(e,0);for(let c=0;c<o;++c){if(i=s,s=l,l=getPoint(e,c+1),!s)continue;const o=s[n],u=s[r];i&&(a=(o-i[n])/3,s[`cp1${n}`]=o-a,s[`cp1${r}`]=u-a*t[c]),l&&(a=(l[n]-o)/3,s[`cp2${n}`]=o+a,s[`cp2${r}`]=u+a*t[c])}}function splineCurveMonotone(e,t="x"){const n=getValueAxis(t),r=e.length,o=Array(r).fill(0),a=Array(r);let i,s,l,c=getPoint(e,0);for(i=0;i<r;++i)if(s=l,l=c,c=getPoint(e,i+1),l){if(c){const e=c[t]-l[t];o[i]=0!==e?(c[n]-l[n])/e:0}a[i]=s?c?sign(o[i-1])!==sign(o[i])?0:(o[i-1]+o[i])/2:o[i-1]:o[i]}monotoneAdjust(e,o,a),monotoneCompute(e,a,t)}function capControlPoint(e,t,n){return Math.max(Math.min(e,n),t)}function capBezierPoints(e,t){let n,r,o,a,i,s=_isPointInArea(e[0],t);for(n=0,r=e.length;n<r;++n)i=a,a=s,s=n<r-1&&_isPointInArea(e[n+1],t),a&&(o=e[n],i&&(o.cp1x=capControlPoint(o.cp1x,t.left,t.right),o.cp1y=capControlPoint(o.cp1y,t.top,t.bottom)),s&&(o.cp2x=capControlPoint(o.cp2x,t.left,t.right),o.cp2y=capControlPoint(o.cp2y,t.top,t.bottom)))}function _updateBezierControlPoints(e,t,n,r,o){let a,i,s,l;if(t.spanGaps&&(e=e.filter((e=>!e.skip))),"monotone"===t.cubicInterpolationMode)splineCurveMonotone(e,o);else{let n=r?e[e.length-1]:e[0];for(a=0,i=e.length;a<i;++a)s=e[a],l=splineCurve(n,s,e[Math.min(a+1,i-(r?0:1))%i],t.tension),s.cp1x=l.previous.x,s.cp1y=l.previous.y,s.cp2x=l.next.x,s.cp2y=l.next.y,n=s}t.capBezierPoints&&capBezierPoints(e,n)}function _isDomSupported(){return"undefined"!=typeof window&&"undefined"!=typeof document}function _getParentNode(e){let t=e.parentNode;return t&&"[object ShadowRoot]"===t.toString()&&(t=t.host),t}function parseMaxStyle(e,t,n){let r;return"string"==typeof e?(r=parseInt(e,10),-1!==e.indexOf("%")&&(r=r/100*t.parentNode[n])):r=e,r}const getComputedStyle=e=>e.ownerDocument.defaultView.getComputedStyle(e,null);function getStyle(e,t){return getComputedStyle(e).getPropertyValue(t)}const positions=["top","right","bottom","left"];function getPositionedStyle(e,t,n){const r={};n=n?"-"+n:"";for(let o=0;o<4;o++){const a=positions[o];r[a]=parseFloat(e[t+"-"+a+n])||0}return r.width=r.left+r.right,r.height=r.top+r.bottom,r}const useOffsetPos=(e,t,n)=>(e>0||t>0)&&(!n||!n.shadowRoot);function getCanvasPosition(e,t){const n=e.touches,r=n&&n.length?n[0]:e,{offsetX:o,offsetY:a}=r;let i,s,l=!1;if(useOffsetPos(o,a,e.target))i=o,s=a;else{const e=t.getBoundingClientRect();i=r.clientX-e.left,s=r.clientY-e.top,l=!0}return{x:i,y:s,box:l}}function getRelativePosition(e,t){if("native"in e)return e;const{canvas:n,currentDevicePixelRatio:r}=t,o=getComputedStyle(n),a="border-box"===o.boxSizing,i=getPositionedStyle(o,"padding"),s=getPositionedStyle(o,"border","width"),{x:l,y:c,box:u}=getCanvasPosition(e,n),f=i.left+(u&&s.left),d=i.top+(u&&s.top);let{width:h,height:g}=t;return a&&(h-=i.width+s.width,g-=i.height+s.height),{x:Math.round((l-f)/h*n.width/r),y:Math.round((c-d)/g*n.height/r)}}function getContainerSize(e,t,n){let r,o;if(void 0===t||void 0===n){const a=_getParentNode(e);if(a){const e=a.getBoundingClientRect(),i=getComputedStyle(a),s=getPositionedStyle(i,"border","width"),l=getPositionedStyle(i,"padding");t=e.width-l.width-s.width,n=e.height-l.height-s.height,r=parseMaxStyle(i.maxWidth,a,"clientWidth"),o=parseMaxStyle(i.maxHeight,a,"clientHeight")}else t=e.clientWidth,n=e.clientHeight}return{width:t,height:n,maxWidth:r||INFINITY,maxHeight:o||INFINITY}}const round1=e=>Math.round(10*e)/10;function getMaximumSize(e,t,n,r){const o=getComputedStyle(e),a=getPositionedStyle(o,"margin"),i=parseMaxStyle(o.maxWidth,e,"clientWidth")||INFINITY,s=parseMaxStyle(o.maxHeight,e,"clientHeight")||INFINITY,l=getContainerSize(e,t,n);let{width:c,height:u}=l;if("content-box"===o.boxSizing){const e=getPositionedStyle(o,"border","width"),t=getPositionedStyle(o,"padding");c-=t.width+e.width,u-=t.height+e.height}c=Math.max(0,c-a.width),u=Math.max(0,r?Math.floor(c/r):u-a.height),c=round1(Math.min(c,i,l.maxWidth)),u=round1(Math.min(u,s,l.maxHeight)),c&&!u&&(u=round1(c/2));return(void 0!==t||void 0!==n)&&r&&l.height&&u>l.height&&(u=l.height,c=round1(Math.floor(u*r))),{width:c,height:u}}function retinaScale(e,t,n){const r=t||1,o=Math.floor(e.height*r),a=Math.floor(e.width*r);e.height=o/r,e.width=a/r;const i=e.canvas;return i.style&&(n||!i.style.height&&!i.style.width)&&(i.style.height=`${e.height}px`,i.style.width=`${e.width}px`),(e.currentDevicePixelRatio!==r||i.height!==o||i.width!==a)&&(e.currentDevicePixelRatio=r,i.height=o,i.width=a,e.ctx.setTransform(r,0,0,r,0,0),!0)}const supportsEventListenerOptions=function(){let e=!1;try{const t={get passive(){return e=!0,!1}};window.addEventListener("test",null,t),window.removeEventListener("test",null,t)}catch(e){}return e}();function readUsedSize(e,t){const n=getStyle(e,t),r=n&&n.match(/^(\d+)(\.\d+)?px$/);return r?+r[1]:void 0}function _pointInLine(e,t,n,r){return{x:e.x+n*(t.x-e.x),y:e.y+n*(t.y-e.y)}}function _steppedInterpolation(e,t,n,r){return{x:e.x+n*(t.x-e.x),y:"middle"===r?n<.5?e.y:t.y:"after"===r?n<1?e.y:t.y:n>0?t.y:e.y}}function _bezierInterpolation(e,t,n,r){const o={x:e.cp2x,y:e.cp2y},a={x:t.cp1x,y:t.cp1y},i=_pointInLine(e,o,n),s=_pointInLine(o,a,n),l=_pointInLine(a,t,n),c=_pointInLine(i,s,n),u=_pointInLine(s,l,n);return _pointInLine(c,u,n)}const getRightToLeftAdapter=function(e,t){return{x:n=>e+e+t-n,setWidth(e){t=e},textAlign:e=>"center"===e?e:"right"===e?"left":"right",xPlus:(e,t)=>e-t,leftForLtr:(e,t)=>e-t}},getLeftToRightAdapter=function(){return{x:e=>e,setWidth(e){},textAlign:e=>e,xPlus:(e,t)=>e+t,leftForLtr:(e,t)=>e}};function getRtlAdapter(e,t,n){return e?getRightToLeftAdapter(t,n):{x:e=>e,setWidth(e){},textAlign:e=>e,xPlus:(e,t)=>e+t,leftForLtr:(e,t)=>e}}function overrideTextDirection(e,t){let n,r;"ltr"!==t&&"rtl"!==t||(n=e.canvas.style,r=[n.getPropertyValue("direction"),n.getPropertyPriority("direction")],n.setProperty("direction",t,"important"),e.prevTextDirection=r)}function restoreTextDirection(e,t){void 0!==t&&(delete e.prevTextDirection,e.canvas.style.setProperty("direction",t[0],t[1]))}function propertyFn(e){return"angle"===e?{between:_angleBetween,compare:_angleDiff,normalize:_normalizeAngle}:{between:_isBetween,compare:(e,t)=>e-t,normalize:e=>e}}function normalizeSegment({start:e,end:t,count:n,loop:r,style:o}){return{start:e%n,end:t%n,loop:r&&(t-e+1)%n==0,style:o}}function getSegment(e,t,n){const{property:r,start:o,end:a}=n,{between:i,normalize:s}=propertyFn(r),l=t.length;let c,u,{start:f,end:d,loop:h}=e;if(h){for(f+=l,d+=l,c=0,u=l;c<u&&i(s(t[f%l][r]),o,a);++c)f--,d--;f%=l,d%=l}return d<f&&(d+=l),{start:f,end:d,loop:h,style:e.style}}function _boundSegment(e,t,n){if(!n)return[e];const{property:r,start:o,end:a}=n,i=t.length,{compare:s,between:l,normalize:c}=propertyFn(r),{start:u,end:f,loop:d,style:h}=getSegment(e,t,n),g=[];let p,b,m,y=!1,_=null;const x=()=>y||l(o,m,p)&&0!==s(o,m),v=()=>!y||0===s(a,p)||l(a,m,p);for(let e=u,n=u;e<=f;++e)b=t[e%i],b.skip||(p=c(b[r]),p!==m&&(y=l(p,o,a),null===_&&x()&&(_=0===s(p,o)?e:n),null!==_&&v()&&(g.push(normalizeSegment({start:_,end:e,loop:d,count:i,style:h})),_=null),n=e,m=p));return null!==_&&g.push(normalizeSegment({start:_,end:f,loop:d,count:i,style:h})),g}function _boundSegments(e,t){const n=[],r=e.segments;for(let o=0;o<r.length;o++){const a=_boundSegment(r[o],e.points,t);a.length&&n.push(...a)}return n}function findStartAndEnd(e,t,n,r){let o=0,a=t-1;if(n&&!r)for(;o<t&&!e[o].skip;)o++;for(;o<t&&e[o].skip;)o++;for(o%=t,n&&(a+=o);a>o&&e[a%t].skip;)a--;return a%=t,{start:o,end:a}}function solidSegments(e,t,n,r){const o=e.length,a=[];let i,s=t,l=e[t];for(i=t+1;i<=n;++i){const n=e[i%o];n.skip||n.stop?l.skip||(r=!1,a.push({start:t%o,end:(i-1)%o,loop:r}),t=s=n.stop?i:null):(s=i,l.skip&&(t=i)),l=n}return null!==s&&a.push({start:t%o,end:s%o,loop:r}),a}function _computeSegments(e,t){const n=e.points,r=e.options.spanGaps,o=n.length;if(!o)return[];const a=!!e._loop,{start:i,end:s}=findStartAndEnd(n,o,a,r);if(!0===r)return splitByStyles(e,[{start:i,end:s,loop:a}],n,t);return splitByStyles(e,solidSegments(n,i,s<i?s+o:s,!!e._fullLoop&&0===i&&s===o-1),n,t)}function splitByStyles(e,t,n,r){return r&&r.setContext&&n?doSplitByStyles(e,t,n,r):t}function doSplitByStyles(e,t,n,r){const o=e._chart.getContext(),a=readStyle(e.options),{_datasetIndex:i,options:{spanGaps:s}}=e,l=n.length,c=[];let u=a,f=t[0].start,d=f;function h(e,t,r,o){const a=s?-1:1;if(e!==t){for(e+=l;n[e%l].skip;)e-=a;for(;n[t%l].skip;)t+=a;e%l!=t%l&&(c.push({start:e%l,end:t%l,loop:r,style:o}),u=o,f=t%l)}}for(const e of t){f=s?f:e.start;let t,a=n[f%l];for(d=f+1;d<=e.end;d++){const s=n[d%l];t=readStyle(r.setContext(createContext(o,{type:"segment",p0:a,p1:s,p0DataIndex:(d-1)%l,p1DataIndex:d%l,datasetIndex:i}))),styleChanged(t,u)&&h(f,d-1,e.loop,u),a=s,u=t}f<d-1&&h(f,d-1,e.loop,u)}return c}function readStyle(e){return{backgroundColor:e.backgroundColor,borderCapStyle:e.borderCapStyle,borderDash:e.borderDash,borderDashOffset:e.borderDashOffset,borderJoinStyle:e.borderJoinStyle,borderWidth:e.borderWidth,borderColor:e.borderColor}}function styleChanged(e,t){return t&&JSON.stringify(e)!==JSON.stringify(t)}export{unclipArea as $,_rlookupByKey as A,_lookupByKey as B,_isPointInArea as C,getAngleFromPoint as D,toPadding as E,each as F,getMaximumSize as G,HALF_PI as H,_getParentNode as I,readUsedSize as J,supportsEventListenerOptions as K,throttled as L,_isDomSupported as M,_factorize as N,finiteOrDefault as O,PI as P,callback as Q,_addGrace as R,_limitValue as S,TAU as T,toDegrees as U,_measureText as V,_int16Range as W,_alignPixel as X,clipArea as Y,renderText as Z,_arrayUnique as _,resolve as a,fontString as a$,toFont as a0,_toLeftRightCenter as a1,_alignStartEnd as a2,overrides as a3,merge as a4,_capitalize as a5,descriptors as a6,isFunction as a7,_attachContext as a8,_createResolver as a9,overrideTextDirection as aA,_textX as aB,restoreTextDirection as aC,drawPointLegend as aD,distanceBetweenPoints as aE,noop as aF,_setMinAndMaxByKey as aG,niceNum as aH,almostWhole as aI,almostEquals as aJ,_decimalPlaces as aK,Ticks as aL,log10 as aM,_longestText as aN,_filterBetween as aO,_lookup as aP,isPatternOrGradient as aQ,getHoverColor as aR,clone$1 as aS,_merger as aT,_mergerIf as aU,_deprecated as aV,_splitKey as aW,toFontString as aX,splineCurve as aY,splineCurveMonotone as aZ,getStyle as a_,_descriptors as aa,mergeIf as ab,uid as ac,debounce as ad,retinaScale as ae,clearCanvas as af,setsEqual as ag,_elementsEqual as ah,_isClickEvent as ai,_isBetween as aj,_readValueToProps as ak,_updateBezierControlPoints as al,_computeSegments as am,_boundSegments as an,_steppedInterpolation as ao,_bezierInterpolation as ap,_pointInLine as aq,_steppedLineTo as ar,_bezierCurveTo as as,drawPoint as at,addRoundedRectPath as au,toTRBL as av,toTRBLCorners as aw,_boundSegment as ax,_normalizeAngle as ay,getRtlAdapter as az,isArray as b,toLineHeight as b0,PITAU as b1,INFINITY as b2,RAD_PER_DEG as b3,QUARTER_PI as b4,TWO_THIRDS_PI as b5,_angleDiff as b6,color as c,defaults as d,effects$1 as e,resolveObjectKey as f,isNumberFinite as g,defined as h,isObject as i,createContext as j,isNullOrUndef as k,listenArrayEvents as l,toPercentage as m,toDimension as n,formatNumber as o,_angleBetween as p,_getStartAndCountOfVisiblePoints as q,requestAnimFrame as r,sign as s,toRadians as t,unlistenArrayEvents as u,valueOrDefault as v,_scaleRangesChanged as w,isNumber as x,_parseObjectDataRadialScale as y,getRelativePosition as z};